"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getContracts = exports.Cores = void 0;
const chains_1 = require("viem/chains");
const devnet_viem_1 = require("./devnet.viem");
const mainnet_viem_1 = require("./mainnet.viem");
const typechain_types_1 = require("../typechain-types");
exports.Cores = {
    BASE: "BASE",
    NEO: "NEO",
    UNIVERSITY: "UNIVERSITY",
};
const getContracts = async (provider, chainId, coreType) => {
    let disputeTemplateRegistry;
    let klerosCore;
    switch (chainId) {
        case chains_1.arbitrum.id:
            disputeTemplateRegistry = typechain_types_1.DisputeTemplateRegistry__factory.connect(mainnet_viem_1.disputeTemplateRegistryConfig.address[chainId], provider);
            klerosCore = typechain_types_1.KlerosCoreNeo__factory.connect(mainnet_viem_1.klerosCoreNeoConfig.address[chainId], provider);
            break;
        case chains_1.arbitrumSepolia.id:
            disputeTemplateRegistry = typechain_types_1.DisputeTemplateRegistry__factory.connect(devnet_viem_1.disputeTemplateRegistryConfig.address[chainId], provider);
            klerosCore = typechain_types_1.KlerosCore__factory.connect(devnet_viem_1.klerosCoreConfig.address[chainId], provider);
            break;
        default:
            throw new Error(`Unsupported chainId: ${chainId}`);
    }
    return { disputeTemplateRegistry, klerosCore };
};
exports.getContracts = getContracts;
