import { type ContractRunner } from "ethers";
import type { IVRFCoordinatorV2Plus, IVRFCoordinatorV2PlusInterface } from "../../../../../../../../@chainlink/contracts/src/v0.8/vrf/dev/interfaces/IVRFCoordinatorV2Plus";
export declare class IVRFCoordinatorV2Plus__factory {
    static readonly abi: readonly [{
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }];
        readonly name: "acceptSubscriptionOwnerTransfer";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "consumer";
            readonly type: "address";
        }];
        readonly name: "addConsumer";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "to";
            readonly type: "address";
        }];
        readonly name: "cancelSubscription";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [];
        readonly name: "createSubscription";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }];
        readonly name: "fundSubscriptionWithNative";
        readonly outputs: readonly [];
        readonly stateMutability: "payable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "startIndex";
            readonly type: "uint256";
        }, {
            readonly internalType: "uint256";
            readonly name: "maxCount";
            readonly type: "uint256";
        }];
        readonly name: "getActiveSubscriptionIds";
        readonly outputs: readonly [{
            readonly internalType: "uint256[]";
            readonly name: "";
            readonly type: "uint256[]";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }];
        readonly name: "getSubscription";
        readonly outputs: readonly [{
            readonly internalType: "uint96";
            readonly name: "balance";
            readonly type: "uint96";
        }, {
            readonly internalType: "uint96";
            readonly name: "nativeBalance";
            readonly type: "uint96";
        }, {
            readonly internalType: "uint64";
            readonly name: "reqCount";
            readonly type: "uint64";
        }, {
            readonly internalType: "address";
            readonly name: "owner";
            readonly type: "address";
        }, {
            readonly internalType: "address[]";
            readonly name: "consumers";
            readonly type: "address[]";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }];
        readonly name: "pendingRequestExists";
        readonly outputs: readonly [{
            readonly internalType: "bool";
            readonly name: "";
            readonly type: "bool";
        }];
        readonly stateMutability: "view";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "consumer";
            readonly type: "address";
        }];
        readonly name: "removeConsumer";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly components: readonly [{
                readonly internalType: "bytes32";
                readonly name: "keyHash";
                readonly type: "bytes32";
            }, {
                readonly internalType: "uint256";
                readonly name: "subId";
                readonly type: "uint256";
            }, {
                readonly internalType: "uint16";
                readonly name: "requestConfirmations";
                readonly type: "uint16";
            }, {
                readonly internalType: "uint32";
                readonly name: "callbackGasLimit";
                readonly type: "uint32";
            }, {
                readonly internalType: "uint32";
                readonly name: "numWords";
                readonly type: "uint32";
            }, {
                readonly internalType: "bytes";
                readonly name: "extraArgs";
                readonly type: "bytes";
            }];
            readonly internalType: "struct VRFV2PlusClient.RandomWordsRequest";
            readonly name: "req";
            readonly type: "tuple";
        }];
        readonly name: "requestRandomWords";
        readonly outputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "requestId";
            readonly type: "uint256";
        }];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }, {
        readonly inputs: readonly [{
            readonly internalType: "uint256";
            readonly name: "subId";
            readonly type: "uint256";
        }, {
            readonly internalType: "address";
            readonly name: "newOwner";
            readonly type: "address";
        }];
        readonly name: "requestSubscriptionOwnerTransfer";
        readonly outputs: readonly [];
        readonly stateMutability: "nonpayable";
        readonly type: "function";
    }];
    static createInterface(): IVRFCoordinatorV2PlusInterface;
    static connect(address: string, runner?: ContractRunner | null): IVRFCoordinatorV2Plus;
}
